<?php

$nzshpcrt_gateways[$num] = array(
	'name' => __( 'ЕРИП', 'wpsc' ),
	'internalname' => ( 'erip'),
	'function' => ( 'gateway_erip'),
	'form' => ( 'form_erip'),
	'submit_function' => ( 'submit_erip'),
	'display_name' => __( 'ЕРИП', 'wpsc' ),
	'payment_type' =>  ( 'erip_checkout'),
);
//Отображение настроек модуля в админ. управления
function form_erip() {
	$output = "
	<tr>
		<td>" . __( 'Номер Поставщика', 'wpsc' ) . "</td>
		<td>
			<input type='text' size='40' value ='".get_option('erip_merchant')."' name='erip_merchant' />
			<p class='description'>
					".__('Выдается Администратором при подключении к EasyPay.', 'wp-e-commerce')."
			</p>
		</td>
	</tr>
	<tr>
		<td>" . __( 'Ключ для авторизации счетов', 'wpsc' ) . "</td>
		<td>
			<input type='text' size='40' value ='".get_option('erip_webkey')."' name='erip_webkey' />
			<p class='description'>
					".__('Web_key (выдается Администратором при подключении к EasyPay).', 'wp-e-commerce')."
			</p>
		</td>
	</tr>
	<tr>
		<td>" . __( 'Срок действия счета', 'wpsc' ) . "</td>
		<td>
			<input type='text' size='40' value ='".get_option('erip_expiried')."' name='erip_expiried' />
			<p class='description'>
					".__('Число от 1 до 30, если период задан в днях или от 600 до 3600*24, если период задан в секундах.', 'wp-e-commerce')."
			</p>
		</td>
	</tr>
	<tr>
		<td>" . __( 'Название Вашего магазина', 'wpsc' ) . "</td>
		<td>
			<input type='text' size='40' value ='".get_option('erip_shop')."' name='erip_shop' />
		</td>
	</tr>
	";

	return $output;
}

function submit_erip(){
	if($_POST['erip_merchant'] != null)
	{
		update_option('erip_merchant',$_POST['erip_merchant']);
	}
	if($_POST['erip_webkey'] != null) 
	{
		update_option('erip_webkey',$_POST['erip_webkey']);
	}
	if($_POST['erip_expiried'] != null) 
	{
		update_option('erip_expiried',$_POST['erip_expiried']);
	}
	if($_POST['erip_shop'] != null) 
	{
		update_option('erip_shop',$_POST['erip_shop']);
	}
	return true;
}

function gateway_erip($seperator, $sessionid){
	global $wpdb, $wpsc_cart;
	
	$purchase_log = $wpdb->get_results("SELECT * FROM `".WPSC_TABLE_PURCHASE_LOGS."` WHERE `sessionid`= ".$sessionid." LIMIT 1", ARRAY_A);
	$merchant = get_option('erip_merchant');
	$webkey	  = get_option('erip_webkey');
	$expiried = get_option('erip_expiried');
	$shop     = get_option('erip_shop');
	$order_id = $purchase_log[0]['id'];
	$sum      = $wpsc_cart->total_price;
	$hash     = md5($merchant.$webkey.$order_id.$sum);

	$post_variables = Array(
		"EP_MerNo"		 => $merchant,
		"EP_OrderNo"	 => $order_id,
		"EP_Sum"		 => $sum,
		"EP_Expires"	 => $expiried,
		"EP_Comment"	 => "Заказ от магазина ".$shop,
		"EP_OrderInfo"	 => "Заказ №".$order_id,
		"EP_Hash"		 => $hash,
		"EP_Success_URL" => home_url( '?erip=success'),
		"EP_Cancel_URL"  => home_url( '?erip=cancel'),
		"EP_PayType"	 => 'PT_ERIP',
		"EP_Encoding"	 => "utf-8",
	);

	$url = 'https://ssl.easypay.by/weborder/?EP_Module=wp_ecommerce_3'; 

	$html = '<form action="' . "" . $url . '" method="post" name="erip_form" >';
	foreach ($post_variables as $name => $value) {
		$html.= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
	}
	$html.= '</form>';
	$html.= ' <script type="text/javascript">';
	$html.= ' document.erip_form.submit();';
	$html.= ' </script>';

	wpsc_empty_cart();//Очищение корзины

	echo $html;
}

function nzshpcrt_erip_result() {
	global $wpdb;	

	$order_id = $_REQUEST['EP_OrderNo'];//Получение номера заказа

	if ($_REQUEST['erip']=='notify') { //Нотификация

		// Получение данных
		$values = array();
		$values['order_mer_code']	= $_REQUEST['order_mer_code'];
		$values['sum']				= $_REQUEST['sum'];
		$values['mer_no']			= $_REQUEST['mer_no'];
		$values['card']				= $_REQUEST['card'];
		$values['purch_date']		= $_REQUEST['purch_date'];
		$values['notify_signature']	= $_REQUEST['notify_signature'];

		$order_id = $values['order_mer_code'];
		$web_key = get_option('erip_webkey');
		$notes = "Счет №$order_id оплачен";//Комментарий для счета в БД
		
		$hash = md5($values['order_mer_code'] . $values['sum'] . $values['mer_no'] . $values['card'] . $values['purch_date']. $web_key);

		if ($hash == $values['notify_signature']){
			$wpdb->query("UPDATE " . WPSC_TABLE_PURCHASE_LOGS . " SET processed = '3', date = '" . time() . "', notes = '" . $notes . "' WHERE id = " . $order_id . " LIMIT 1");//Изменение статуса на "Оплата принята"
			header("HTTP/1.0 200 OK"); // генерация HTTP-заголовка
		}else{
			header("HTTP/1.0 400 Bad Request");
		}
	
	}
	if ($_REQUEST['erip']=='success'){
		//Вывод сообщения
		_e("<div style='text-align:center; padding:10px 0;'>
			<div style='color:#00a12d; font-size:20px; font-weight:bold;'>Счет добавлен в систему ЕРИП для оплаты.</div>
				<div style='color:#00a12d; font-size:20px; font-weight:bold; padding-bottom:15px;'>Номер заказа для оплаты: $order_id
				</div>
			</div>" , 'wp-e-commerce'); 
	}
	if ($_REQUEST['erip']=='cancel'){

		$notes = "Ошибка оплаты счета";//Комментарий для счета в БД		
		$wpdb->query("UPDATE " . WPSC_TABLE_PURCHASE_LOGS . " SET processed = '6', date = '" . time() . "', notes = '" . $notes . "' WHERE id = " . $order_id . " LIMIT 1");//Изменение статуса на "Отклоненный платеж"
		_e("<div style='text-align:center; padding:10px 0;'>
			<div style='color:#D1001D; font-size:20px; font-weight:bold;'>Ошибка при проведении оплаты</div>
			</div>" , 'wp-e-commerce'); //Вывод сообщения

		

		}
}
add_action('get_template_part_content', 'nzshpcrt_erip_result');
